using Microsoft.ApplicationInsights.DependencyCollector;

namespace Api.Extensions
{
	public static class WebApplicationBuilderExtensions
	{
		public static void ConfigureServicesAI(this IServiceCollection services)
		{
			//https://github.com/microsoft/ApplicationInsights-Kubernetes

			var aiOptions = new Microsoft.ApplicationInsights.AspNetCore.Extensions.ApplicationInsightsServiceOptions();
#if DEBUG
			aiOptions.EnableAdaptiveSampling = false;
			aiOptions.DeveloperMode = true;
#endif
			services.ConfigureTelemetryModule<DependencyTrackingTelemetryModule>((module, o) =>
			{
				module.EnableSqlCommandTextInstrumentation = true;
			});
			services.AddApplicationInsightsTelemetry(aiOptions);
			
			// ---------------------------------------------
			// ENABLE THIS FOR ERROR !!!!!!!
			// ---------------------------------------------
			services.AddApplicationInsightsKubernetesEnricher();
		}
		
		public static void CreateApi(this WebApplicationBuilder builder)
		{
			
			builder.Services.ConfigureServicesAI();
			
		}
	}
}